import java.awt.Color;

/**
 * Write a description of class Particle here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Particle {
    public int life;
    public Color current;
    public Color target;
    public boolean die = false;
    
    public Particle(int life, Color current, Color target) {
        this.life = life;
        this.current = current;
        this.target = target;
    }
    
    public Particle(int life, Color current) {
        this.life = life;
        this.current = current;
        target =  current;
    }
    
    public void tick() {
        int r = current.getRed();
        int g = current.getGreen();
        int b = current.getBlue();
        if(current.getRed() < target.getRed()) r++;
        else if(current.getRed() > target.getRed()) r--;
        if(current.getGreen() < target.getGreen()) g++;
        else if(current.getGreen() > target.getGreen()) g--;
        if(current.getBlue() < target.getBlue()) b++;
        else if(current.getBlue() > target.getBlue()) b--;
        int decay = 6;
        if(life > decay) life -= decay;
        else {
            life = 0;
            die = true;
        }
        if(life<256) current = new Color(r, g, b, life);
        else current = new Color(r, g, b);
    }
    
    public void add(Particle particle) {
        life += particle.life;
        int r = target.getRed()+(particle.target.getRed()-target.getRed())/2;
        int g = target.getGreen()+(particle.target.getGreen()-target.getGreen())/2;
        int b = target.getBlue()+(particle.target.getBlue()-target.getBlue())/2;
        target = new Color(r, g, b);
    }
}
