import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;

/**
 * Write a description of class Worldy here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Worldy extends World {
    GreenfootImage img;
    Particle[][] particles;
    Color color = Color.red;
    Color back = Color.white;
    
    public Worldy() {
        super(600, 400, 1);
        particles = new Particle[getWidth()][getHeight()];
        img = new GreenfootImage(getWidth(), getHeight());
    }
    
    public void act() {
        MouseInfo mouse = Greenfoot.getMouseInfo();
        if(Greenfoot.isKeyDown("1")) color = Color.black;
        else if(Greenfoot.isKeyDown("2")) color = Color.white;
        else if(Greenfoot.isKeyDown("3")) color = Color.red;
        else if(Greenfoot.isKeyDown("4")) color = Color.orange;
        else if(Greenfoot.isKeyDown("5")) color = Color.yellow;
        else if(Greenfoot.isKeyDown("6")) color = Color.green;
        else if(Greenfoot.isKeyDown("7")) color = Color.blue;
        else if(Greenfoot.isKeyDown("8")) color = new Color(255, 0, 255);
        else if(Greenfoot.isKeyDown("9")) color = Color.gray;
        if(mouse!=null) {
            img.setColor(color);
            if(Greenfoot.mousePressed(null) || Greenfoot.mouseDragged(null)) {
                img.fillOval(mouse.getX()-5, mouse.getY()-5, 10, 10);
            }
        }
        if("r".equals(Greenfoot.getKey())) {
            int i = Greenfoot.getRandomNumber(6);
            GreenfootImage IMG = null;
            if(i == 0) IMG = new GreenfootImage("airplane.png");
            if(i == 1) IMG = new GreenfootImage("apple1.png");
            if(i == 2) IMG = new GreenfootImage("bomb.png");
            if(i == 3) IMG = new GreenfootImage("cactus.png");
            if(i == 4) IMG = new GreenfootImage("castle.png");
            if(i == 5) {
                if(UserInfo.getMyInfo().isStorageAvailable()) IMG = UserInfo.getMyInfo().getUserImage();
                else IMG = new GreenfootImage("rivets.jpg");
            }
            if(IMG!=null) {
                IMG.scale(IMG.getWidth()*3, IMG.getHeight()*3);
                img.clear();
                img.drawImage(IMG, img.getWidth()/2-IMG.getWidth()/2, img.getHeight()/2-IMG.getHeight()/2);
            }
        } else if(Greenfoot.isKeyDown("e")) {
            img = new GreenfootImage(getWidth(), getHeight());
        }
        if(Greenfoot.isKeyDown("f")) back = color;
        getBackground().setColor(back);
        getBackground().fill();
        for(int y = 0; y < getHeight(); y++) {
            for(int x = 0; x < getWidth(); x++) {
                if(particles[x][y]!=null) {
                    particles[x][y].tick();
                    getBackground().setColorAt(x, y, particles[x][y].current);
                }
                if(particles[x][y] != null && !particles[x][y].die && y>0) {
                    int rand = Greenfoot.getRandomNumber(3);
                    if(rand == 0 && x>0) {
                        if(particles[x-1][y-1]!=null) particles[x-1][y-1] = particles[x][y];
                        else particles[x-1][y-1] = particles[x][y];
                        particles[x][y] = null;
                    }
                    if(rand == 1 && x<getWidth()-1) {
                        if(particles[x+1][y-1]!=null) particles[x+1][y-1] = particles[x][y];
                        else particles[x+1][y-1] = particles[x][y];
                        particles[x][y] = null;
                    }
                    if(rand == 2) {
                        if(particles[x][y-1]!=null) particles[x][y-1] = particles[x][y];
                        else particles[x][y-1] = particles[x][y];
                        particles[x][y] = null;
                    }
                } else {
                    particles[x][y] = null;
                }
                int n = 300;
                int fx = getWidth()/2-img.getWidth()/2;
                int ex = (getWidth()/2+img.getWidth()/2)-1;
                int fy = getHeight()/2-img.getHeight()/2;
                int ey = (getHeight()/2+img.getHeight()/2)-1;
                if(x > fx && x < ex && y > fy && y < ey && Greenfoot.getRandomNumber(10)==0) {
                    if(particles[x][y]!=null && img.getColorAt(x-fx, y-fy).getAlpha()>0) {
                        particles[x][y].add(new Particle(n, img.getColorAt(x-fx, y-fy)));
                    } else if(img.getColorAt(x-fx, y-fy).getAlpha()>0) {
                        particles[x][y] = new Particle(n, img.getColorAt(x-fx, y-fy));
                    }
                }
            }
        }
        if(mouse!=null && mouse.getX()<getWidth() && mouse.getY()<getHeight() && mouse.getX()>=0 && mouse.getY()>=0) {
            if(particles[mouse.getX()][mouse.getY()]!=null) {
                particles[mouse.getX()][mouse.getY()].add(new Particle(300, color));
            } else {
                particles[mouse.getX()][mouse.getY()] = new Particle(300, color);
            }
        }
    }
}
